



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Spring Cloud Config 配置属性覆盖优先级。</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Spring Cloud Config 配置属性覆盖优先级。</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-26 16:35:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<pre class="prettyprint linenums">    /**<br />
     * Flag to indicate that the external properties should override system properties.<br />
     * Default true.<br />
     */<br />
    private boolean overrideSystemProperties = true;

    /**<br />
     * Flag to indicate that {@link #isSystemPropertiesOverride()<br />
     * systemPropertiesOverride} can be used. Set to false to prevent users from changing<br />
     * the default accidentally. Default true.<br />
     */<br />
    private boolean allowOverride = true;

    /**<br />
     * Flag to indicate that when {@link #setAllowOverride(boolean) allowOverride} is<br />
     * true, external properties should take lowest priority, and not override any<br />
     * existing property sources (including local config files). Default false.<br />
     */<br />
    private boolean overrideNone = false;</pre>
</div>
<p>上面的代码截取至PropertySourceBootstrapProperties.java，可以看到有三个属性来控制覆盖的设置。</p>
<p>我们先不管Spring Cloud Config，就单单SpringBoot的变量覆盖根据官网的说法是以下的顺序（从上往下覆盖，也就是说最后的优先级是最低的）。</p>
<p>官网地址：https://docs.spring.io/spring-boot/docs/current/reference/html/boot-features-external-config.html</p>
<div>
<pre class="prettyprint linenums">Spring Boot uses a very particular PropertySource order that is designed to allow sensible overriding of values. Properties are considered in the following order:

Devtools global settings properties on your home directory (~/.spring-boot-devtools.properties when devtools is active).<br />
@TestPropertySource annotations on your tests.<br />
@SpringBootTest#properties annotation attribute on your tests.<br />
Command line arguments.<br />
Properties from SPRING_APPLICATION_JSON (inline JSON embedded in an environment variable or system property)<br />
ServletConfig init parameters.<br />
ServletContext init parameters.<br />
JNDI attributes from java:comp/env.<br />
Java System properties (System.getProperties()).<br />
OS environment variables.<br />
A RandomValuePropertySource that only has properties in random.*.<br />
Profile-specific application properties outside of your packaged jar (application-{profile}.properties and YAML variants)<br />
Profile-specific application properties packaged inside your jar (application-{profile}.properties and YAML variants)<br />
Application properties outside of your packaged jar (application.properties and YAML variants).<br />
Application properties packaged inside your jar (application.properties and YAML variants).<br />
@PropertySource annotations on your @Configuration classes.<br />
Default properties (specified using SpringApplication.setDefaultProperties).</pre>
</div>
<p>很清晰了吧，但如果走Spring Cloud Config这一套，如果你想本地提供一些参数覆盖远程配置文件的属性，在没有远程配置文件的允许下，是无法覆盖的。</p>
<p>所以他提供了那三个属性用来控制覆盖的选项。</p>
<p>另外，如果你不了解系统级(OS)环境变量和Java运行时参数的话，请看一下这个问答：https://stackoverflow.com/questions/13112038/difference-between-system-getenv-system-getproperty</p>
<p>好了，回到主题，我们可以看到overrideSystemProperties以及allowOverride这两个值是默认开启的。</p>
<p>其中overrideSystemProperties是覆盖Java运行时参数的也就是说，你通过下面的方式提供的属性，是会被远程的配置文件给覆盖的。</p>
<div>
<pre class="prettyprint linenums">java -jar -Dserver.port=6666 myapp.jar</pre>
</div>
<p>如果此时你的拓展属性文件中，包含了server.port这个值的话，那么你不会得到期望的6666，要使用的话，请在你的拓展属性文件中，注意，是在你的拓展属性文件中将这个值设置为false.</p>
<p>我们再来看一下allowOverride这个参数，上面说了，这个值是默认开启的，在注释中我们很清楚的了解到，如果允许被覆盖的话，这个值必须被设置为ture，但他默认就是ture，所以我们一般不用关心。</p>
<p>接下来看一下最重要的那个参数，即overrideNone，这个值依赖于上面所说的那个allowOverride等于true的情况下才有用，意思很清楚，注释说的很明白，即：<strong>如果为ture，</strong><strong>外部拓展属性文件不会覆盖任何已经存在的值。已存在的值是指，非系统环境变量（如果你将overrideSystemProperties设置为false除外）。但如果 如此一来，我们通过命令行指定的参数 --xxxxx.xxxx=value，就不会被覆盖掉了。</strong></p>
<p>有点绕，但是多看几遍之后还是能明白的。</p>
<p>一般来说，我们只需要将overrideNone设置为true，就能够通过命令行的方式，即--xxxx.xxx=value的方式设置属性值了，而且不会被覆盖掉。</p>
<p><strong>最后千万千万注意的是，上面这三个属性存在于外部拓展时才会生效，如果你说为什么没有效果啊，请考虑为Spring Cloud Config当中存储的配置文件上加上上面所说的那些选项。</strong></p>
<p><strong>https://github.com/spring-cloud/spring-cloud-config/issues/359</strong></p>
<p><strong>这里作者说了：&ldquo;&nbsp;an app can't decide on its own that it can override configuration from the remote source&rdquo;，即应用程序不能够自己决定是否能够覆盖，而是要在远程的配置文件中指明！</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mngypq.html">Git 分支管理和冲突解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1p000q.html">Chapter 2&colon; 随机变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlw3218.html">返本求源&mdash;&mdash;DOM元素的特性与属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/4952r3z9.html">vuejs入门小demo-搜索大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ym4o5q.html">Delphi  RxRichEdit高级操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1e6g28.html">uploadify插件实现多个图片上传并预览</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn13poq.html">Node&period;JS &plus; MongoDB技术浅谈</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zmnee9.html">Android各代码层获取系统时间的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1z5ldq.html">UNIX环境高级编程、 现代操作系统概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25dwlvq.html">kubernetes版本融合解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2vywx9.html">ssh自动登录，脚本实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyyvggq.html">JQuery 操作数组 each、map、grep、filter</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvn5jx8.html">linux（centos）无中文输入，如何解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj40vz9.html">【SRM-07 D】天才麻将少女KPM</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllkxyxq.html">python3 cookie</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25y31vq.html">Unity3D 移动摇杆处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw4lo09.html">Harmonic Value Description HDU - 5916</a>
		</li>
						<li><a href="https://www.batexi.com/a/9022ywoq.html">JavaScript（三）：数据类型转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pw2z0q.html">maven 自动部署到 tomcat7</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p14leq.html">SELINUX导致数据修改权限不成功</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e44lkj9.html">Appcan开发笔记&colon;导出Excel文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/9600v7j9.html">EXCEL文件导入时报&lowbar;未在本地计算机上注册Microsoft&period;ACE&period;OLEDB&period;12&period;0提供程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwwm7v9.html">python&lowbar;文件操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r27oj9.html">hihoCoder编程练习赛69</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o14k1lq.html">phpstudy 产生You don&amp;&num;39&semi;t have permission to access &sol; on this server&period;解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25kwkxq.html">crontab工具安装和检查</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25kwooq.html">HTML5  常用标签整理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2e1e19.html">css 表单标签两端对齐</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5ng3dq.html">phpcms有二级导航并且高亮效果代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd2dmd9.html">mybatis 通过实体类进行查询</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
